<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  block_articles_breadcrumb.php                            ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

function articles_breadcrumb($block_name, $top_id, $rss_on_breadcrumb = false)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings;
	global $category_id, $is_reviews;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");

	$t->set_file("block_body", "block_breadcrumb.html");

	$article_id = get_param("article_id");
	$category_id = get_param("category_id");
	$search_category_id = get_param("search_category_id");
	if(strlen($search_category_id)) {
		$category_id = $search_category_id;
	}

	if (!strlen($category_id) && strlen($article_id)) {
		$category_id = get_db_value("SELECT category_id FROM " . $table_prefix . "articles_assigned WHERE article_id=" . $db->tosql($article_id, INTEGER));
	}

	$t->set_var("index_href", "index.php");
	$t->set_var("HOME_PAGE_TITLE", HOME_PAGE_TITLE);

	if ($category_id) {
		$current_id = $category_id;
		$sql  = " SELECT category_id, category_name, friendly_url, parent_category_id ";
		$sql .= " FROM " . $table_prefix . "articles_categories";
		$sql .= " WHERE category_id=";
		while ($current_id)
		{
			$db->query($sql . $db->tosql($current_id, INTEGER));
			if($db->next_record()) {
				$category_name = $db->f("category_name");
				$category_name = get_translation($category_name);
				$friendly_url = $db->f("friendly_url");
				if ($friendly_urls && $friendly_url) {
					$tree_url = $friendly_url . $friendly_extension;
				} else {
					$tree_url = "articles.php?category_id=". $current_id;
				}
				$t->set_var("tree_url", $tree_url);
				$t->set_var("tree_title", $category_name);
				$t->rparse("tree");
				$current_id= $db->f("parent_category_id");
			} else {
				$current_id = "0";
			}
		}
	}

	if (strlen($article_id)) {
		$sql = "SELECT article_title, friendly_url FROM " . $table_prefix . "articles WHERE article_id=" . $db->tosql($article_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$article_title = get_translation($db->f("article_title"));
			$friendly_url = $db->f("friendly_url");
			if ($friendly_urls && $friendly_url) {
				$tree_url = $friendly_url . $friendly_extension;
				if ($category_id) {
					$tree_url .= "?category_id=" . urlencode($category_id);
				}
			} else if ($category_id) {
				$tree_url = "article.php?category_id=" . urlencode($category_id) . "&article_id=" . urlencode($article_id);
			} else {
				$tree_url = "article.php?article_id=" . urlencode($article_id);
			}

			$t->set_var("tree_url", $tree_url);
			$t->set_var("tree_title", htmlspecialchars($article_title));
			$t->parse("tree", true);
		}
	}

	if ($is_reviews) {
		$tree_url = "articles_reviews.php?category_id=" . urlencode($category_id) . "&article_id=" . urlencode($article_id);
		$t->set_var("tree_url", $tree_url);
		$t->set_var("tree_title", REVIEWS_MSG);
		$t->parse("tree", true);
	}

	if ($rss_on_breadcrumb) {
		$t->set_var("tree_current_id", $category_id);
		$t->set_var("rss_href","articles_rss.php");
		$t->set_var("rss_url","articles_rss.php?category_id=" . urlencode($category_id));
		$t->parse("rss", false);
	}
	$t->parse("block_body", false);
	$t->parse($block_name, true);

}

?>