<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  block_basket_recommended.php                             ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function basket_recommended($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings, $current_page, $restrict_products_images;
	global $language_code;
	global $sc_item_id, $item_added, $sc_errors;
	global $currency_left, $currency_right, $currency_rate;

	$records_per_page = 10;
	$pr_columns = 2;

	$user_id = get_session("session_user_id");
	$user_name = get_session("session_user_name");
	$user_type_id = get_session("session_user_type_id");
	$discount_type = get_session("session_discount_type");
	$discount_amount = get_session("session_discount_amount");
	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");
	$display_products = get_setting_value($settings, "display_products", 0);
	$product_no_image = get_setting_value($settings, "product_no_image", "");
	$price_type = get_session("session_price_type");
	if ($price_type == 1) {
		$price_field = "trade_price";
		$sales_field = "trade_sales";
	} else {
		$price_field = "price";
		$sales_field = "sales_price";
	}

	$item_id = get_param("item_id");
	$t->set_file("block_body", "block_basket_recommended.html");
	$t->set_var("product_details_href", "product_details.php");

	$recommended_title = str_replace("{user_name}", $user_name, PRODUCTS_RECOMMENDED_TITLE);
	$t->set_var("PRODUCTS_RECOMMENDED_TITLE", $recommended_title);
	$t->set_var("PROD_AVAILABILITY_MSG",  PROD_AVAILABILITY_MSG);
	$t->set_var("ADD_TO_CART_MSG",        ADD_TO_CART_MSG);
	$t->set_var("MORE_MSG",               MORE_MSG);
	$t->set_var("READ_MORE_MSG",          READ_MORE_MSG);
	$t->set_var("CLICK_HERE_MSG",         CLICK_HERE_MSG);
	$t->set_var("PRICE_MSG",              PRICE_MSG);
	$t->set_var("OUR_PRICE_MSG",          OUR_PRICE_MSG);
	$t->set_var("cl", $currency_left);
	$t->set_var("cr", $currency_right);

	$items_ids = "";
	$shopping_cart = get_session("shopping_cart");
	if (is_array($shopping_cart)) {
		foreach ($shopping_cart as $cart_id => $item) {
			$properties_more = $item["PROPERTIES_MORE"];
			if (!$properties_more) { 
				$item_id = $item["ITEM_ID"];
				if (strlen($items_ids)) { $items_ids .= ",";	}
				$items_ids .= $item_id;
			}
		}
	}

	if (!strlen($items_ids)) {
		return;
	}

	// set up variables for navigator
	$total_records = 0; 
	$recommended = array(); $recom_ids = "";

	// get related items first
	$sql  = " SELECT i.item_id ";
	$sql .= " FROM " . $table_prefix . "items i, " . $table_prefix . "items_related ir ";
	$sql .= " WHERE i.item_id=ir.related_id ";
	$sql .= " AND ir.item_id IN (" . $items_ids . ")";
	$sql .= " AND ir.related_id NOT IN (" . $items_ids . ")";
	$sql .= " AND i.is_showing=1 AND i.is_approved=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " GROUP BY i.item_id ";
	$db->query($sql);
	while ($db->next_record()) {
		$total_records++;
		$item_id = $db->f("item_id");
		$recommended[] = $item_id;
	}

	// get accessories
	$sql  = " SELECT i.item_id ";
	$sql .= " FROM " . $table_prefix . "items i, " . $table_prefix . "items_accessories ia ";
	$sql .= " WHERE i.item_id=ia.accessory_id ";
	$sql .= " AND ia.item_id IN (" . $items_ids . ")";
	$sql .= " AND ia.accessory_id NOT IN (" . $items_ids . ")";
	$sql .= " AND i.is_showing=1 AND i.is_approved=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " GROUP BY i.item_id ";
	$db->query($sql);
	while ($db->next_record()) {
		$item_id = $db->f("item_id");
		if (!in_array($item_id, $recommended)) {
			$total_records++;
			$recommended[] = $item_id;
		}
	}

	// check if recommended products exists
	if (sizeof($recommended) > 0) {
		$recom_ids = join(",", $recommended);
	} else {
		return;
	}

	// prepare navigator for recommended products
	$pages_number = 5;
	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", $current_page);
	$page_number = $n->set_navigator("pr_navigator", "rpage", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$t->set_var("rpage", $page_number);

	$sql  = " SELECT i.item_id, i.item_type_id, i.tax_free, i.item_name, i.friendly_url, i.short_description, i.small_image, i.small_image_alt, ";
	$sql .= " i.buying_price, i." . $price_field . ", i.is_price_edit, i." . $sales_field . ", i.is_sales, i.tax_free, ";
	$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action, ";
	$sql .= " i.use_stock_level, i.disable_out_of_stock, i.hide_out_of_stock, i.hide_add_list, ";
	$sql .= " i.stock_level, st_in.shipping_time_desc AS in_stock_message, st_out.shipping_time_desc AS out_stock_message ";
	$sql .= " FROM ((((" . $table_prefix . "items i ";
	$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON (i.item_id=ip.item_id AND ip.min_quantity=1 AND ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . ")) ";
	$sql .= " LEFT JOIN " . $table_prefix . "manufacturers m ON i.manufacturer_id=m.manufacturer_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_in ON i.shipping_in_stock=st_in.shipping_time_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_out ON i.shipping_out_stock=st_out.shipping_time_id) ";
	$sql .= " WHERE i.item_id IN (" . $recom_ids . ")";
	//$sql .= " ORDER BY related_order ";
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query($sql);
	if($db->next_record())
	{
		$t->set_var("pr_column", (100 / $pr_columns) . "%");
		$pr_number = 0;
		do
		{
			$pr_number++;
			$item_id = $db->f("item_id");
			$item_type_id = $db->f("item_type_id");
			$item_name = get_translation($db->f("item_name"));
			$friendly_url = $db->f("friendly_url");
			$short_description = get_translation($db->f("short_description"));
			$tax_free = $db->f("tax_free");
			$stock_level = $db->f("stock_level");
			$use_stock_level = $db->f("use_stock_level");
			$disable_out_of_stock = $db->f("disable_out_of_stock");
			$hide_out_of_stock = $db->f("hide_out_of_stock");
			$hide_add_list = $db->f("hide_add_list");
			$quantity_limit = ($use_stock_level && ($disable_out_of_stock || $hide_out_of_stock));
			if ($stock_level > 0) {
				$shipping_time_desc = $db->f("in_stock_message");
			} else {
				$shipping_time_desc = $db->f("out_stock_message");
			}

			if ($friendly_urls && $friendly_url) {
				$details_url = $friendly_url . $friendly_extension;
			} else {
				$details_url = "product_details.php?item_id=".urlencode($item_id);
			}

			$properties = show_items_properties($item_id, $item_type_id, $tax_free, "list");
			$is_properties  = $properties["is_any"];
			$properties_ids = $properties["ids"];
			$selected_price = $properties["price"];
			$components_price = $properties["components_price"];
			$components_tax_price = $properties["components_tax_price"];

			$t->set_var("item_id", $item_id);
			$t->set_var("item_name", $item_name);
			$t->set_var("item_name_strip", htmlspecialchars(strip_tags($item_name)));
			$t->set_var("details_url", $details_url);
			$t->set_var("short_description", $short_description);
			$t->set_var("pr_tax_price", "");
			$t->set_var("pr_tax_sales", "");

			$t->set_var("sc_errors", "");
			if($item_id == $sc_item_id) {
				if ($sc_errors) {
					$t->set_var("errors_list", $sc_errors);
					$t->parse("sc_errors", false);
				}
			} 

			if(strlen($shipping_time_desc)) {
				$t->set_var("shipping_time_desc", $shipping_time_desc);
				$t->parse("pr_availability", false);
			} else {
				$t->set_var("pr_availability", "");
			}


			if ($display_products != 2 || strlen($user_id)) {

				set_quantity_control($quantity_limit, $stock_level);

				$price = $db->f($price_field);
				$is_price_edit = $db->f("is_price_edit");
				$is_sales = $db->f("is_sales");
				$sales_price = $db->f($sales_field);
				$buying_price = $db->f("buying_price");
				$tax_free = $db->f("tax_free");
				$user_price = $db->f("user_price");
				$user_price_action = $db->f("user_price_action");
				if ($user_price > 0 && ($user_price_action > 0 || !$discount_type)) {
					if ($sales_price > 0) {
						$sales_price = $user_price;
					} else {
						$price = $user_price;
					}
				}
				if ($user_price_action != 1) {
					if ($discount_type == 1 || $discount_type == 3) {
						$price -= round(($price * $discount_amount) / 100, 2);
						$sales_price -= round(($sales_price * $discount_amount) / 100, 2);
					} else if ($discount_type == 2) {
						$price -= round($discount_amount, 2);
						$sales_price -= round($discount_amount, 2);
					} else if ($discount_type == 4) {
						$price -= round((($price - $buying_price) * $discount_amount) / 100, 2);
						$sales_price -= round((($sales_price - $buying_price) * $discount_amount) / 100, 2);
					}
				}

				$price = $price * $currency_rate;
				$sales_price = $sales_price * $currency_rate;

				$base_price = calculate_price($price, $is_sales, $sales_price);
				$t->set_var("base_price", $base_price);
				if ($is_price_edit) {
					$t->set_var("pr_price_class", "editprice");
					$t->set_var("pr_price_readonly", "");
					if ($price > 0) {
						$control_price = number_format($price, 2);
					} else {
						$control_price = "";
					}
					$t->set_var("pe", "1");
					$t->set_var("pr_price", $control_price);
					$t->set_var("pr_price_control", "<input name=\"price\" type=\"text\" class=\"editprice\" value=\"" . $control_price . "\">");
					$t->sparse("pr_price_block", false);
					$t->set_var("pr_sales", "");
				} else if($sales_price > 0 && $sales_price != $price && $is_sales) {

					set_tax_price($item_id, $item_type_id, $price, $sales_price + $selected_price, $tax_free, "pr_price", "pr_sales_price", "pr_tax_sales", true, $components_price, $components_tax_price);

					$t->set_var("pe", "0");
					$t->set_var("pr_price_class", "realprice");
					$t->set_var("pr_price_readonly", "readonly");
					$t->sparse("pr_price_block", false);
					$t->sparse("pr_sales", false);
				}
				else
				{
					set_tax_price($item_id, $item_type_id, $price + $selected_price, 0, $tax_free, "pr_price", "", "pr_tax_price", true, $components_price, $components_tax_price);

					$t->set_var("pe", "0");
					$t->set_var("pr_price_class", "ourprice");
					$t->set_var("pr_price_readonly", "readonly");
					$t->sparse("pr_price_block", false);
					$t->set_var("pr_sales", "");
				}
				srand ((double) microtime() * 1000000);
				$rnd = rand();
				$product_quantity = isset($settings["product_quantity"]) ? $settings["product_quantity"] : "";
				$buy_link = $db->f("buy_link");
				if($buy_link) {
					$t->set_var("buy_href", $db->f("buy_link") . $db->f("affiliate_code"));
				} else if($is_properties || $product_quantity == "LISTBOX" || $product_quantity == "TEXTBOX") {
					$t->set_var("buy_href", "javascript:document.form_" . $item_id . ".submit();");
				} else {
					$buy_link = $current_page . "?item_id=" . $item_id . "&cart=ADD&rnd=" . $rnd . "&rpage=" . $page_number . "&rp=" . urlencode($current_page) . "#p" . $item_id;
					$t->set_var("buy_href", $buy_link);
				}

				if ($hide_add_list) {
					$t->set_var("add_button_disabled", "");
					$t->set_var("add_button", "");
				} else {
					if ($use_stock_level && $stock_level < 1 && $disable_out_of_stock) {
						$t->set_var("add_button", "");
						$t->sparse("add_button_disabled", false);
					} else {
						$t->set_var("add_button_disabled", "");
						$t->sparse("add_button", false);
					}
				}

			}

			$small_image = $db->f("small_image");
			if (!$small_image) {
				$small_image = $product_no_image;
			}
			$small_image_alt = $db->f("small_image_alt");
			if($small_image)
			{
				if (preg_match("/^http\:\/\//", $small_image)) {
					$image_size = "";
				} else {
	        $image_size = @GetImageSize($small_image);
					if (isset($restrict_products_images) && $restrict_products_images) { $small_image = "image_show.php?item_id=".$item_id."&type=small"; }
				}
				if (!strlen($small_image_alt)) { $small_image_alt = $item_name; }
        $t->set_var("alt", htmlspecialchars($small_image_alt));
        $t->set_var("src", htmlspecialchars($small_image));
				if(is_array($image_size))
				{
	        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
  	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
				}
				else
				{
	        $t->set_var("width", "");
  	      $t->set_var("height", "");
				}
				$t->sparse("pr_small_image", false);
			}
			else
			{
				$t->set_var("pr_small_image", "");
			}

			$t->parse("pr_cols");
			if($pr_number % $pr_columns == 0)
			{
				$t->parse("pr_rows");
				$t->set_var("pr_cols", "");
			}
			
		} while ($db->next_record());              	

		if($pr_number % $pr_columns != 0)
			$t->parse("pr_rows");

		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>