<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  order_confirmation.php                                   ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./includes/record.php");
	include_once ("./includes/shopping_cart.php");
	include_once ("./includes/order_items.php");
	include_once ("./includes/order_links.php");
	include_once ("./includes/parameters.php");
	include_once ("./messages/".$language_code."/cart_messages.php");

	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];
	$currency_value = $currency["value"];
	$referer = get_session("session_referer");
	$initial_ip = get_session("session_initial_ip");
	$cookie_ip = get_session("session_cookie_ip");
	$visit_number = get_session("session_visit_number");

	$order_id = get_session("session_order_id");
	$vc = get_session("session_vc");
	$payment_id = ""; $payment_info = "";
	$order_errors = check_order($order_id, $vc);
	if(!$order_errors) {
		$sql  = " SELECT ps.payment_id, ps.payment_info ";
		$sql .= " FROM " . $table_prefix . "orders o, " . $table_prefix . "payment_systems ps ";
		$sql .= " WHERE o.payment_id=ps.payment_id ";
		$sql .= " AND o.order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$payment_id = $db->f("payment_id");
			$payment_info = get_translation($db->f("payment_info"));
			$payment_info = get_currency_message($payment_info, $currency);
		}
	}

	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_info'";
	$db->query($sql);
	while($db->next_record()) {
		$order_info[$db->f("setting_name")] = $db->f("setting_value");
	}

	$setting_type = "credit_card_info_" . $payment_id;
	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
	$db->query($sql);
	while($db->next_record()) {
		$cc_info[$db->f("setting_name")] = $db->f("setting_value");
	}

	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_confirmation'";
	$db->query($sql);
	while($db->next_record()) {
		$order_confirmation[$db->f("setting_name")] = $db->f("setting_value");
	}

	$confirmed_order_status = 3;

	$r = new VA_Record($table_prefix . "orders");
	$r->errors = $order_errors;

	$r->add_where("order_id", INTEGER);
	$r->set_value("order_id", $order_id);

	$r->add_textbox("error_message", TEXT);
	$r->add_textbox("pending_message", TEXT);
	$r->add_textbox("transaction_id", TEXT);
	$r->change_property("transaction_id", USE_IN_UPDATE, false);

	$action = get_param("action");
	$return_page = "order_final.php";
	$items_text = "";
	
	$t = new VA_Template("./js");
	$t->set_file("confirm_js","confirm.js");
	$t->parse("confirm_js", false);

	$t->templates_path = $settings["templates_dir"];
  $t->set_file("main","order_confirmation.html");
	$t->set_var("site_url", $settings["site_url"]);
	$t->set_var("referer", $referer);
	$t->set_var("referrer", $referer);
	$t->set_var("HTTP_REFERER", $referer);
	$t->set_var("initial_ip", $initial_ip);
	$t->set_var("cookie_ip", $cookie_ip);
	$t->set_var("visit_number", $visit_number);

	$t->set_var("CHECKOUT_CONFIRM_TITLE", CHECKOUT_CONFIRM_TITLE);     
	$t->set_var("CART_TITLE",          CART_TITLE);     
	$t->set_var("EMPTY_CART_MSG",      EMPTY_CART_MSG);     
	$t->set_var("PROD_CODE_MSG",       PROD_CODE_MSG);
	$t->set_var("PROD_TITLE_COLUMN",   PROD_TITLE_COLUMN);     
	$t->set_var("PROD_QTY_COLUMN",     PROD_QTY_COLUMN);         
	$t->set_var("PROD_PRICE_COLUMN",   PROD_PRICE_COLUMN);       
	$t->set_var("PROD_TOTAL_COLUMN",   PROD_TOTAL_COLUMN);  
	$t->set_var("GOODS_TOTAL_MSG",     GOODS_TOTAL_MSG); 
	$t->set_var("TOTAL_DISCOUNT_MSG",  TOTAL_DISCOUNT_MSG); 
	$t->set_var("GOODS_WITH_DISCOUNT_MSG",GOODS_WITH_DISCOUNT_MSG); 
	$t->set_var("CART_TOTAL_MSG",      CART_TOTAL_MSG);     

	$t->set_var("PERSONAL_DETAILS_MSG", PERSONAL_DETAILS_MSG);
	$t->set_var("DELIVERY_DETAILS_MSG", DELIVERY_DETAILS_MSG);
	$t->set_var("PAYMENT_DETAILS_MSG",  PAYMENT_DETAILS_MSG);
	$t->set_var("DELIVERY_MSG",         DELIVERY_MSG);
	$t->set_var("INVOICE_TO_MSG",       INVOICE_TO_MSG);
	$t->set_var("DELIVERY_TO_MSG",      DELIVERY_TO_MSG);

	$t->set_var("SAME_DETAILS_MSG",   SAME_DETAILS_MSG);
	$t->set_var("REGISTER_BUTTON",    REGISTER_BUTTON);
	$t->set_var("UPDATE_BUTTON",      UPDATE_BUTTON);
	$t->set_var("CANCEL_BUTTON",      CANCEL_BUTTON);
	$t->set_var("LOGIN_FIELD",        LOGIN_FIELD);
	$t->set_var("PASSWORD_FIELD",     PASSWORD_FIELD);
	$t->set_var("CONFIRM_PASS_FIELD", CONFIRM_PASS_FIELD);
	$t->set_var("NAME_FIELD",         NAME_FIELD);
	$t->set_var("FIRST_NAME_FIELD",   FIRST_NAME_FIELD);
	$t->set_var("LAST_NAME_FIELD",    LAST_NAME_FIELD);
	$t->set_var("COMPANY_SELECT_FIELD",COMPANY_SELECT_FIELD);
	$t->set_var("COMPANY_NAME_FIELD", COMPANY_NAME_FIELD);
	$t->set_var("EMAIL_FIELD",        EMAIL_FIELD);
	$t->set_var("STREET_FIRST_FIELD", STREET_FIRST_FIELD);
	$t->set_var("STREET_SECOND_FIELD",STREET_SECOND_FIELD);
	$t->set_var("CITY_FIELD",         CITY_FIELD);
	$t->set_var("PROVINCE_FIELD",     PROVINCE_FIELD);
	$t->set_var("STATE_FIELD",        STATE_FIELD);
	$t->set_var("ZIP_FIELD",          ZIP_FIELD);
	$t->set_var("COUNTRY_FIELD",      COUNTRY_FIELD);
	$t->set_var("PHONE_FIELD",        PHONE_FIELD);
	$t->set_var("DAYTIME_PHONE_FIELD",DAYTIME_PHONE_FIELD);
	$t->set_var("EVENING_PHONE_FIELD",EVENING_PHONE_FIELD);
	$t->set_var("CELL_PHONE_FIELD",   CELL_PHONE_FIELD);
	$t->set_var("FAX_FIELD",          FAX_FIELD);

	$t->set_var("CC_NAME_FIELD",         CC_NAME_FIELD);
	$t->set_var("CC_NAME_DESC",          CC_NAME_DESC);
	$t->set_var("CC_FIRST_NAME_FIELD",   CC_FIRST_NAME_FIELD);
	$t->set_var("CC_LAST_NAME_FIELD",    CC_LAST_NAME_FIELD);
	$t->set_var("CC_NUMBER_FIELD",       CC_NUMBER_FIELD);
	$t->set_var("CC_START_DATE_FIELD",   CC_START_DATE_FIELD);
	$t->set_var("CC_EXPIRY_DATE_FIELD",  CC_EXPIRY_DATE_FIELD);
	$t->set_var("CC_TYPE_FIELD",         CC_TYPE_FIELD);
	$t->set_var("CC_ISSUE_NUMBER_FIELD", CC_ISSUE_NUMBER_FIELD);
	$t->set_var("CC_ISSUE_NUMBER_DESC",  CC_ISSUE_NUMBER_DESC);
	$t->set_var("CC_SECURITY_CODE_FIELD",CC_SECURITY_CODE_FIELD);
	$t->set_var("PAY_WITHOUT_CC_MSG",    PAY_WITHOUT_CC_MSG);
	$t->set_var("PAY_WITHOUT_CC_FIELD",  PAY_WITHOUT_CC_FIELD);
	$t->set_var("PAY_WITHOUT_CC_DESC",   PAY_WITHOUT_CC_DESC);

	$t->set_var("CONTINUE_BUTTON",    CONTINUE_BUTTON);

	if(strlen($action))
	{

		if($r->is_empty("order_id")) {
			$r->errors .= "Missing <b>Order number</b>.<br>";
		}

		if(!strlen($r->errors))
		{
			$variables = array();
			$cart_items = array();
			// get orders variables
			$items_text = show_order_items($order_id);

			$variables["charset"] = CHARSET;
			$variables["order_id"] = $order_id;
			$variables["items"] = $items_text;
			$variables["basket"] = $items_text;
			$variables["description"] = $items_text;

			$sql = "SELECT * FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
			$db->query($sql);
			if($db->next_record()) {
				for($i = 0; $i < sizeof($parameters); $i++) {
					$variables[$parameters[$i]] = $db->f($parameters[$i]);
					$variables["delivery_" . $parameters[$i]] = $db->f("delivery_" . $parameters[$i]);
				}
				for($i = 0; $i < sizeof($cc_parameters); $i++) {
					$variables[$cc_parameters[$i]] = $db->f($cc_parameters[$i]);
				}
				if (strlen($variables["cc_name"]) && !strlen($variables["cc_first_name"]) && !strlen($variables["cc_last_name"])) {
					$cc_name = $variables["cc_name"];
					$name_parts = explode(" ", $cc_name, 2);
					if (sizeof($name_parts) == 2) {
						$variables["cc_first_name"] = $name_parts[0];
						$variables["cc_last_name"] = $name_parts[1];
					} else {
						$variables["cc_first_name"] = $name_parts[0];
						$variables["cc_last_name"] = "";
					}
				} else if (!strlen($variables["cc_name"]) && (strlen($variables["cc_first_name"]) || strlen($variables["cc_last_name"]))) {
					$variables["cc_name"] = trim($variables["cc_first_name"] . " " . $variables["cc_last_name"]);
				}
				$address = $variables["address2"] ? ($variables["address1"] . " " . $variables["address2"]) : $variables["address1"];
				$delivery_address = $variables["delivery_address2"] ? ($variables["delivery_address1"] . " " . $variables["delivery_address2"]) : $variables["delivery_address1"];
				$address_number = (preg_match("/\d+/", $address, $match)) ? $match[0] : ""; 
				$delivery_address_number = (preg_match("/\d+/", $delivery_address, $match)) ? $match[0] : ""; 
				$variables["address"] = $address;
				$variables["address_number"] = $address_number;
				$variables["delivery_address"] = $delivery_address;
				$variables["delivery_address_number"] = $delivery_address_number;
	  
				$order_placed_date = $db->f("order_placed_date", DATETIME);
				$cc_start_date = $db->f("cc_start_date", DATETIME);
				$cc_expiry_date = $db->f("cc_expiry_date", DATETIME);

				$timestamp = mktime ($order_placed_date[HOUR], $order_placed_date[MINUTE], $order_placed_date[SECOND], $order_placed_date[MONTH], $order_placed_date[DAY], $order_placed_date[YEAR]);
				$vc = md5($order_id . $order_placed_date[HOUR].$order_placed_date[MINUTE].$order_placed_date[SECOND]);

				$user_id = $db->f("user_id");
				$affiliate_code = $db->f("affiliate_code");
				$order_currency_code = $db->f("currency_code");
				$order_currency_rate = $db->f("currency_rate");
				$goods_total = $db->f("goods_total");
				$total_discount = $db->f("total_discount");
				$properties_total = $db->f("properties_total");
				$properties_taxable = $db->f("properties_taxable");
				$shipping_cost = $db->f("shipping_cost");
				$shipping_taxable = $db->f("shipping_taxable");
				$total_quantity = $db->f("total_quantity");
				$weight_total = $db->f("weight_total");
				$total_discount = $db->f("total_discount");
				$tax_name = $db->f("tax_name");
				$tax_percent = $db->f("tax_percent");
				$tax_cost = $db->f("tax_total");
				$processing_fee = $db->f("processing_fee");
				$order_total = $db->f("order_total");

				// get payment rate for the selected gateway
				$payment_rate = get_payment_rate($payment_id, $order_currency_rate);
	  
				// get numeric code
				$order_currency = get_currency($order_currency_code);
				$order_currency_value = $order_currency["value"];

				$variables["vc"] = $vc;
				$variables["timestamp"] = $timestamp;
				$variables["order_placed_timestamp"] = $timestamp;
				$variables["order_placed_date"] = va_date($datetime_show_format, $order_placed_date);
				$variables["cc_start_date"] = ""; $variables["cc_start_date_short"] = "";
				$variables["cc_start_year"] = ""; $variables["cc_start_yyyy"] = ""; $variables["cc_start_month"] = "";
				if (is_array($cc_start_date)) {
					$variables["cc_start_date"] = va_date(array("MM"," / ","YYYY"), $cc_start_date);
					$variables["cc_start_date_short"] = va_date(array("MM"," / ","YY"), $cc_start_date);
					$variables["cc_start_year"] = va_date(array("YY"), $cc_start_date);
					$variables["cc_start_yyyy"] = va_date(array("YYYY"), $cc_start_date);
					$variables["cc_start_month"] = va_date(array("MM"), $cc_start_date);
				}
				$variables["cc_expiry_date"] = ""; $variables["cc_expiry_date_short"] = "";
				$variables["cc_expiry_year"] = ""; $variables["cc_expiry_yyyy"] = ""; $variables["cc_expiry_month"] = "";
				if (is_array($cc_expiry_date)) {
					$variables["cc_expiry_date"] = va_date(array("MM"," / ","YYYY"), $cc_expiry_date);
					$variables["cc_expiry_date_short"] = va_date(array("MM"," / ","YY"), $cc_expiry_date);
					$variables["cc_expiry_year"] = va_date(array("YY"), $cc_expiry_date);
					$variables["cc_expiry_yyyy"] = va_date(array("YYYY"), $cc_expiry_date);
					$variables["cc_expiry_month"] = va_date(array("MM"), $cc_expiry_date);
				}
	  
				$variables["user_id"] = $user_id;
				$variables["affiliate_code"] = $affiliate_code;
				$variables["currency_code"] = $order_currency_code;
				$variables["currency_value"] = $order_currency_value;
				$variables["currency_rate"] = $order_currency_rate;
				$variables["goods_total"] = round($goods_total * $payment_rate, 2);
				$variables["total_discount"] = round($total_discount * $payment_rate, 2);
				$goods_with_discount = $goods_total - $total_discount;
				$variables["goods_with_discount"] = round($goods_with_discount * $payment_rate, 2);
				$variables["total_quantity"] = $total_quantity;
				$variables["total_items"] = $total_items;
				$variables["weight_total"] = $weight_total;
				$variables["total_weight"] = $weight_total;
				$variables["properties_total"] = number_format($properties_total * $payment_rate, 2, ".", "");
				$variables["properties_taxable"] = $properties_taxable;
				$variables["shipping_cost"] = round($shipping_cost * $payment_rate, 2);
				$variables["shipping_taxable"] = $shipping_taxable;
				$variables["total_discount"] = $total_discount;
				$variables["tax_name"] = $tax_name;
				$variables["tax_percent"] = $tax_percent;
				$variables["tax_cost"] = $tax_cost;
				$variables["processing_fee"] = number_format($processing_fee * $payment_rate, 2, ".", "");
				$variables["order_total"] = number_format($order_total * $payment_rate, 2, ".", "");
				$variables["order_total_100"] = round($order_total * $payment_rate * 100, 0);

				$variables["company_select"] = get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($variables["company_id"], INTEGER));
				$variables["state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["state_code"], TEXT));
				if (strlen($variables["state_code"])) {
					$variables["state_code_or_province"] = $variables["state_code"];
					$variables["state_or_province"] = $variables["state"];
				} else {
					$variables["state_code_or_province"] = $variables["province"];
					$variables["state_or_province"] = $variables["province"];
				}
				$country_name = ""; $country_number = "";
				$sql = "SELECT * FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["country_code"], TEXT);
				$db->query($sql);
				if ($db->next_record()) {
					$country_name = $db->f("country_name");
					$country_number = $db->f("country_iso_number");
				}
				$variables["country"] = $country_name;
				$variables["country_number"] = $country_number;
				$variables["delivery_company_select"] = get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($variables["delivery_company_id"], INTEGER));
				$variables["delivery_state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["delivery_state_code"], TEXT));
				if (strlen($variables["delivery_state_code"])) {
					$variables["delivery_state_code_or_province"] = $variables["delivery_state_code"];
					$variables["delivery_state_or_province"] = $variables["delivery_state"];
				} else {
					$variables["delivery_state_code_or_province"] = $variables["delivery_province"];
					$variables["delivery_state_or_province"] = $variables["delivery_province"];
				}
				$delivery_country_name = ""; $delivery_country_number = "";
				$sql = "SELECT * FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["delivery_country_code"], TEXT);
				$db->query($sql);
				if ($db->next_record()) {
					$delivery_country_name = $db->f("country_name");
					$delivery_country_number = $db->f("country_iso_number");
				}
				$variables["delivery_country"] = $delivery_country_name;
				$variables["delivery_country_number"] = $delivery_country_number;
				$variables["cc_type"] = get_db_value("SELECT credit_card_code FROM " . $table_prefix . "credit_cards WHERE credit_card_id=" . $db->tosql($variables["cc_type"], INTEGER));
				$variables["cc_number"] = get_session("session_cc_number");
				$variables["cc_number_last"] = get_session("session_cc_number_last");
				$variables["cc_security_code"] = get_session("session_cc_code");

				$t->set_vars($db->Record);
				$t->set_var("goods_total", $currency_left . number_format($variables["goods_total"] * $currency_rate, 2) . $currency_right);
				$t->set_var("shipping_cost", $currency_left . number_format($variables["shipping_cost"] * $currency_rate, 2) . $currency_right);
				$t->set_var("tax_percent", number_format($variables["tax_percent"], 2) . "%");
				$t->set_var("state", $variables["state"]);
				$t->set_var("country", $variables["country"]);
				$t->set_var("delivery_state", $variables["delivery_state"]);
				$t->set_var("delivery_country", $variables["delivery_country"]);
				$t->set_var("order_placed_date", $variables["order_placed_date"]);
				$t->set_var("cc_start_date", $variables["cc_start_date"]);
				$t->set_var("cc_expiry_date", $variables["cc_expiry_date"]);
				$t->set_var("cc_number_last", $variables["cc_number_last"]);
			}

			if (!strlen($payment_id)) { // check for payment_id if we loose it somewhere
				$sql = "SELECT payment_id FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
				$payment_id = get_db_value($sql);
				if (!strlen($payment_id)) { // if we missed it again look for it in payment_systems table 
					$sql = "SELECT payment_id FROM " . $table_prefix . "payment_systems WHERE is_active=1 AND is_advanced=1 ";
					$payment_id = get_db_value($sql);
				}
			}
			$is_advanced = false;
			if (strlen($payment_id))
			{
				$db->query("SELECT * FROM " . $table_prefix . "payment_systems WHERE is_active=1 AND payment_id=" . $db->tosql($payment_id, INTEGER));
				if ($db->next_record()) {
					$is_advanced  = $db->f("is_advanced");
					$advanced_url = $db->f("advanced_url");
					$advanced_php_lib = $db->f("advanced_php_lib");
					$success_status_id = $db->f("success_status_id");
					$pending_status_id = $db->f("pending_status_id");
					$failure_status_id = $db->f("failure_status_id");
					$failure_action = $db->f("failure_action");
				}
			}

			$error_message = ""; $pending_message = ""; $transaction_id = "";
			if ($is_advanced && strlen($advanced_php_lib)) 
			{
				$post_params = ""; $payment_parameters = array(); $pass_parameters = array(); $fp_hash_name = "";
				$db->query("SELECT * FROM " . $table_prefix . "payment_parameters WHERE payment_id=" . $db->tosql($payment_id, INTEGER));
				while($db->next_record())
				{
					$parameter_source = $db->f("parameter_source");
					$parameter_name = $db->f("parameter_name");
					$parameter_type = $db->f("parameter_type");
					$not_passed = $db->f("not_passed");
					if (strtolower($parameter_name) == "x_fp_hash" && $parameter_type == "VARIABLE") {
						$fp_hash_name = $parameter_name;
						$fp_not_passed = $not_passed;
					} else if (preg_match("/\{digit\}/", $parameter_name) || preg_match("/\{no_digit\}/", $parameter_name)) {
						for($i = 0; $i < sizeof($cart_items); $i++) {
							$cart_item = $cart_items[$i];
							$digit_parameter = str_replace("{digit}", ($i + 1), $parameter_name);
							$digit_parameter = str_replace("{no_digit}", "", $digit_parameter);
							if($parameter_type == "CONSTANT") {
								$parameter_value = $parameter_source;
							} else if($parameter_type == "VARIABLE") {
								if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
									$parameter_value = $parameter_source;
									for($p = 0; $p < sizeof($matches[1]); $p++) {
										$l_source = strtolower($matches[1][$p]);
										if (isset($cart_item[$l_source])) {
											$parameter_value = str_replace("{".$l_source."}", $cart_item[$l_source], $parameter_value);
										}
									}
								} else {
									$l_source = strtolower($parameter_source);
									$parameter_value = isset($cart_item[$l_source]) ? $cart_item[$l_source] : $parameter_source;
								}
							}
							$payment_parameters[strtolower($digit_parameter)] = $parameter_value;
							if (!$not_passed) {
								$pass_parameters[strtolower($digit_parameter)] = 1;
								if ($post_params) { $post_params .= "&"; } 
								$post_params .= $digit_parameter . "=" . urlencode($parameter_value);
							} else {
								$pass_parameters[strtolower($digit_parameter)] = 0;
							}
						}
					} else {
						if($parameter_type == "CONSTANT") {
							$parameter_value = $parameter_source;
						} else if($parameter_type == "VARIABLE") {
							if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
								$parameter_value = $parameter_source;
								for($p = 0; $p < sizeof($matches[1]); $p++) {
									$l_source = strtolower($matches[1][$p]);
									if (isset($variables[$l_source])) {
										$parameter_value = str_replace("{".$l_source."}", $variables[$l_source], $parameter_value);
									}
								}
							} else {
								$l_source = strtolower($parameter_source);
								$parameter_value = isset($variables[$l_source]) ? $variables[$l_source] : $parameter_source;
							}
						}
						$payment_parameters[strtolower($parameter_name)] = $parameter_value;
						if (!$not_passed) {
							$pass_parameters[strtolower($parameter_name)] = 1;
							if ($post_params) { $post_params .= "&"; } 
							$post_params .= $parameter_name . "=" . urlencode($parameter_value);
						} else {
							$pass_parameters[strtolower($parameter_name)] = 0;
						}
					}
				}
	    
				if (strlen($fp_hash_name)) {
					$x_login = isset($payment_parameters["x_login"]) ? $payment_parameters["x_login"] : "";
					$x_tran_key = isset($payment_parameters["x_tran_key"]) ? $payment_parameters["x_tran_key"] : "";
					$x_currency_code = isset($payment_parameters["x_currency_code"]) ? $payment_parameters["x_currency_code"] : "";
	    
					$fp_hash_value = calculate_fp ($x_login, $x_tran_key, $variables["order_total"], $variables["order_id"], $variables["timestamp"], $x_currency_code);
					$payment_parameters["x_fp_hash"] = $fp_hash_value;
					if(!$fp_not_passed) {
						if ($post_params) { $post_params .= "&"; } 
						$post_params .= $fp_hash_name . "=" . urlencode($fp_hash_value);
					}
				}

				// use foreign php library to handle transaction
				if (file_exists($advanced_php_lib)) {
					include_once ($advanced_php_lib);
				} else {
					$error_message = "Can't find appropriative php library: " . $advanced_php_lib;
				}
	
				if (strlen($error_message)) {
					$order_status = $failure_status_id;
				} else if (strlen($pending_message)) {
					$order_status = $pending_status_id; 
				} else {
					$order_status = $success_status_id; 
				}
				$r->set_value("error_message", $error_message);
				$r->set_value("pending_message", $pending_message);
				if (strlen($transaction_id)) {
					$r->set_value("transaction_id", $transaction_id);
					$r->change_property("transaction_id", USE_IN_UPDATE, true);
				}

				// update order status for payment
				update_order_status($order_id, $order_status, false);
			} else {
				// update order status for confirmed status
				update_order_status($order_id, $confirmed_order_status, false);
			}

			$r->update_record();

			if (strlen($error_message) && $failure_action == 1) {
				header("Location: credit_card_info.php?payment_error=1");
				exit;
			} else {
				header("Location: " . $return_page);
				exit;
			}
		
		}
	}

	if(!$order_errors) {
		$items_text = show_order_items($order_id);
	}

	$t->set_var("order_confirmation", "order_confirmation.php");
	$t->set_var("vc", htmlspecialchars($vc));

	$personal_number = 0;
	$delivery_number = 0;
	for($i = 0; $i < sizeof($parameters); $i++)
	{                                    
		$personal_param = "show_" . $parameters[$i];
		$delivery_param = "show_delivery_" . $parameters[$i];
		$r->add_textbox($parameters[$i], TEXT);
		$r->add_textbox("delivery_" . $parameters[$i], TEXT);
		if(isset($order_info[$personal_param]) && $order_info[$personal_param] == 1) {
			$personal_number++;
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if(isset($order_info[$delivery_param]) && $order_info[$delivery_param] == 1) {
			$delivery_number++;
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$r->add_textbox("cc_name", TEXT);
	$r->add_textbox("cc_first_name", TEXT);
	$r->add_textbox("cc_last_name", TEXT);
	$r->add_textbox("cc_number", TEXT);
	$r->add_textbox("cc_start_date", DATETIME);
	$r->change_property("cc_start_date", VALUE_MASK, array("MM", " / ", "YYYY"));
	$r->add_textbox("cc_expiry_date", DATETIME);
	$r->change_property("cc_expiry_date", VALUE_MASK, array("MM", " / ", "YYYY"));
	$r->add_textbox("cc_type", INTEGER);
	$r->add_textbox("cc_issue_number", INTEGER);
	$r->add_textbox("cc_security_code", TEXT);
	$r->add_textbox("pay_without_cc", TEXT);

	if(!$order_errors) {
		$r->get_db_values();
		$r->set_value("cc_number", get_session("session_cc_number"));
		$r->set_value("cc_security_code", get_session("session_cc_code"));
	}

	$cc_number = $r->get_value("cc_number");
	$cc_number = format_cc_number($cc_number, "-", true);
	$r->set_value("cc_number", $cc_number);
	for($i = 0; $i < sizeof($cc_parameters); $i++) { 
		$cc_param_name = $cc_parameters[$i];
		if(!isset($cc_info["show_" . $cc_param_name]) || $cc_info["show_" . $cc_param_name] != 1 || $r->is_empty($cc_param_name)) {
			$r->parameters[$cc_param_name][SHOW] = false;
		}
	}


	$r->set_value("company_id", get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($r->get_value("company_id"), INTEGER)));
	$r->set_value("state_code", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($r->get_value("state_code"), TEXT)));
	$r->set_value("country_code", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($r->get_value("country_code"), TEXT)));
	$r->set_value("delivery_company_id", get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($r->get_value("delivery_company_id"), INTEGER)));
	$r->set_value("delivery_state_code", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($r->get_value("delivery_state_code"), TEXT)));
	$r->set_value("delivery_country_code", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($r->get_value("delivery_country_code"), TEXT)));
	$r->set_value("cc_type", get_db_value("SELECT credit_card_name FROM " . $table_prefix . "credit_cards WHERE credit_card_id=" . $db->tosql($r->get_value("cc_type"), INTEGER)));

	$r->set_parameters();

	if($personal_number > 0) {
		$t->parse("personal", false);
	}

	if($delivery_number > 0) {
		$t->parse("delivery", false);
	}

	if(trim($payment_info)) {
		$t->set_block("payment_info", $payment_info);
		$t->parse("payment_info", false);
		$t->global_parse("payment_info_block", false, false, true);
	} else {
		$t->set_var("payment_info_block", "");
	}

	$intro_text = trim($order_confirmation["intro_text"]);
	$intro_text = get_translation($intro_text);
	$intro_text = get_currency_message($intro_text, $currency);
	if ($intro_text) {
		$t->set_var("intro_text", $intro_text);
		$t->parse("intro_block", false);
	}

	include_once ("./header.php");
	include_once ("./footer.php");

	$t->pparse("main");

?>